/*

  VxD  C++
=============================

       ,
       .

*/



#include "prefix.h"

#include <string.h>

#define WANTVXDWRAPS

#include "basedef.h"

#include "vmm.h"


extern "C" {
  #include "vxdwraps.h"
}




// ########################################################################
//
// 
// ===========
//
// ########################################################################





#define VxD_Name {'T', 'i', 'n', 'y', 'V', 'x', 'D', ' '}

#define VxD_Id 0

#define VersionMajor 1
#define VersionMinor 0





// ########################################################################
//
// 
// =========
//
// ########################################################################





void VxD_Control (void);        //   





// ########################################################################
//
// 
// =========
//
// ########################################################################





//
//    (DDB)
// ==============================
//

extern "C"
_declspec (dllexport)
struct VxD_Desc_Block DDB = {

    0,                          //  DDB_Next
    DDK_VERSION,                //  DDB_SDK_Version
    VxD_Id,                     //  DDB_Req_Device_Number
    VersionMajor,               //  DDB_Dev_Major_Version
    VersionMinor,               //  DDB_Dev_Minor_Version
    0,                          //  DDB_Flags
    VxD_Name,                   //  DDB_Name[8]
    UNDEFINED_INIT_ORDER,       //  DDB_Init_Order
    DWORD (VxD_Control),        //  DDB_Control_Proc
    0,                          //  DDB_V86_API_Proc
    0,                          //  DDB_PM_API_Proc
    0,                          //  DDB_V86_API_CSIP
    0,                          //  DDB_PM_API_CSIP
    0,                          //  DDB_Reference_Data
    0,                          //  DDB_Service_Table_Ptr
    0,                          //  DDB_Service_Table_Size
    0,                          //  DDB_Win32_Service_Table
    'Prev',                     //  DDB_Prev
    sizeof (DDB),               //  DDB_Size
    'Rsv1',                     //  DDB_Reserved1
    'Rsv2',                     //  DDB_Reserved2
    'Rsv3',                     //  DDB_Reserved3

};






// ########################################################################
//
//  
// =================
//
// ########################################################################





//
//   
// ==============================
//
//     ,  TRUE  
//  ,  FALSE -  .

static int _cdecl VxD_Handler (

  DWORD EAX,
  DWORD EBX,
  DWORD ECX,
  DWORD EDX,
  DWORD ESI,
  DWORD EDI,
  DWORD EBP
  
) {

  ULONG Msg = EAX;

  //
  //    ,   TRUE
  //

  if (Msg == CREATE_THREAD || Msg == TERMINATE_THREAD) {

    char *Ev = (Msg == CREATE_THREAD)? "Created" : "Terminated";

    char Str [100];

    _Sprintf (Str, "%s thread %X", Ev, EDI); // EDI -  

    strcat (Str, "\n");

    Out_Debug_String (Str);

  }

  return TRUE;

  UNREFERENCED (EBX, ECX, EDX, ESI, EBP);

}






// ########################################################################
//
// ,  
// ===========================
//
// ########################################################################





//
//   
// =============================
//

_declspec (naked)
void VxD_Control (void) {

  _asm {
  
    push ebp
    push edi
    push esi
    push edx
    push ecx
    push ebx
    push eax

    call VxD_Handler            //  
    rcr eax, 1                  //    EAX  CF
    cmc                         //  CF

    pop eax
    pop ebx
    pop ecx
    pop edx
    pop esi
    pop edi
    pop ebp

    ret

  }

}
